//The Relative Brokers Vigor Index RBVI. Based on code RSI.mq4,  Copyright  2004, MetaQuotes Software Corp. http://www.metaquotes.net/
#property  copyright "Copyright  2004, MetaQuotes Software Corp., BECEMAL 2010"
#property  link      "http://www.becemal.ru/"
#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_level1 40
#property indicator_level2 60
#property indicator_buffers 3
#property indicator_color1 RoyalBlue
extern int RBVIPeriod=10;
extern int smooth=5;
double RBVIBuffer[];
double PosBuffer[];
double NegBuffer[];
int init()
  {
   string   short_name = "RBVI("+RBVIPeriod+")";
   SetIndexBuffer(1,PosBuffer);
   SetIndexBuffer(2,NegBuffer);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_NONE);
   SetIndexStyle(2,DRAW_NONE);
   SetIndexBuffer(0,RBVIBuffer);
   IndicatorShortName(short_name);
   SetIndexLabel(0,"RBVI");
   SetIndexDrawBegin(0,RBVIPeriod);
   PosBuffer[-1]=0;
   NegBuffer[-1]=0;
   PosBuffer[0]=0;
   NegBuffer[0]=0;
   return(0);
  }
int start()
{
   int    i, counted_bars = IndicatorCounted();
   double rel, negative, positive, sumn, sump;
   if(Bars<=RBVIPeriod) return(0);
   if(counted_bars<1)
      for(i=1;i<=RBVIPeriod;i++) RBVIBuffer[Bars-i]=50.0;
   i=Bars-RBVIPeriod-1;
   if(counted_bars>=RBVIPeriod) i=Bars-counted_bars-1;
   while(i >= 0)  {
      sumn=0.0; sump=0.0;
      rel=iATR(NULL,0,RBVIPeriod,i) * Volume[i]- iATR(NULL,0,RBVIPeriod,i+1) * Volume[i+1];
      if(rel>0) sump= rel;
      else      sumn=-rel;
      positive=(PosBuffer[i+1]*(RBVIPeriod-1)+sump)/RBVIPeriod;
      negative=(NegBuffer[i+1]*(RBVIPeriod-1)+sumn)/RBVIPeriod;
      PosBuffer[i]=positive;
      NegBuffer[i]=negative;
      if(negative==0.0) RBVIBuffer[i]=0.0;
      else RBVIBuffer[i]=iSsm(100.0*(1.0-1.0/(1.0+positive/negative)),smooth,i);
      i--;
     }
   return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

#define Pi 3.14159265358979323846264338327950288
double workSsm[][2];
#define _tprice 0
#define _ssm    1

double workSsmCoeffs[][4];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3

//
//
//
//
//

double iSsm(double tprice, double period, int i, int instanceNo=0)
{
   if (period<=1) return(tprice); i = Bars-i-1;
   if (ArrayRange(workSsm,0) !=Bars)                 ArrayResize(workSsm,Bars);
   if (ArrayRange(workSsmCoeffs,0) < (instanceNo+1)) ArrayResize(workSsmCoeffs,instanceNo+1);
   if (workSsmCoeffs[instanceNo][_period] != period)
   {
      workSsmCoeffs[instanceNo][_period] = period;
      double a1 = MathExp(-1.414*Pi/period);
      double b1 = 2.0*a1*MathCos(1.414*Pi/period);
         workSsmCoeffs[instanceNo][_c2] = b1;
         workSsmCoeffs[instanceNo][_c3] = -a1*a1;
         workSsmCoeffs[instanceNo][_c1] = 1.0 - workSsmCoeffs[instanceNo][_c2] - workSsmCoeffs[instanceNo][_c3];
   }

   //
   //
   //
   //
   //

      int s = instanceNo*2;   
          workSsm[i][s+_tprice] = tprice;
          workSsm[i][s+_ssm]    = workSsmCoeffs[instanceNo][_c1]*(workSsm[i][s+_tprice]+workSsm[i-1][s+_tprice])/2.0 + 
                                  workSsmCoeffs[instanceNo][_c2]*workSsm[i-1][s+_ssm]                                + 
                                  workSsmCoeffs[instanceNo][_c3]*workSsm[i-2][s+_ssm]; 
   return(workSsm[i][s+_ssm]);
}